<?php

/**
 * SimpleXMLExtended Class
 *
 * Extends the default PHP SimpleXMLElement class by 
 * allowing the addition of cdata
 *
 * @since 1.0
 *
 * @param string $cdata_text
 */
class SimpleXMLExtended extends SimpleXMLElement{   
  public function addCData($cdata_text){   
   $node= dom_import_simplexml($this);   
   $no = $node->ownerDocument;   
   $node->appendChild($no->createCDATASection($cdata_text));   
  } 
} 

/**
 * Get XML Data
 *
 * Turns the XML file into an object 
 *
 * @since 1.0
 *
 * @param string $file
 * @return object
 */
function getXML($file) {
	$xml = file_get_contents($file);
	$data = simplexml_load_string($xml, 'SimpleXMLExtended', LIBXML_NOCDATA);
	return $data;
}

/**
 * XML Save
 *
 * @since 2.0
 * @todo create and chmod file before ->asXML call (if it doesnt exist already, if so, then just chmod it.)
 *
 * @param object $xml
 * @param string $file Filename that it will be saved as
 * @return bool
 */
function XMLsave($xml, $file) {
	$success = $xml->asXML($file) === TRUE;
}

/**
 * Clean URL
 *
 * @since 1.0
 *
 * @param string $text
 * @return string
 */
function clean_url($text)  { 
	$text = strip_tags(strtolower($text)); 
	$code_entities_match = array(' ?',' ','--','&quot;','!','@','#','$','%','^','&','*','(',')','+','{','}','|',':','"','<','>','?','[',']','\\',';',"'",',','/','*','+','~','`','=','.'); 
	$code_entities_replace = array('','-','-','','','','','','','','','','','','','','','','','','','','','','','',''); 
	$text = str_replace($code_entities_match, $code_entities_replace, $text); 
	$text = urlencode($text);
	$text = str_replace('--','-',$text);
	$text = rtrim($text, "-");
	return $text; 
} 



//-----------------------------------------------------------------//
//-----------------------------------------------------------------//
//-----------------------------------------------------------------//

  $err='';
  session_start();
  $imagenCadena = $_SESSION["imagencadena"]; 
  $pot = trim(strtolower($imagenCadena));
  $server_name = getenv ("SERVER_NAME");       // Server Name
  $request_uri = getenv ("REQUEST_URI");       // Requested URI
  global $i18n;
//-----------------------------------------------------
//             Comienza Guestbook
//-----------------------------------------------------
  if (@$_GET['tp'] == 'guest') {
	if (isset($_POST['guest-submit'])) {
		 $id = @$_GET['idf'] ;
                 $answ = @$_GET['ans'] ;
	         $log_file= $_POST['guest']['q_file'];
                 $EMAIL = $_POST['guest']['q_email'];
		 $MIURL= $_POST['guest']['q_uri'];
		 $posmiar= strpos($MIURL, 'miarr=');
                 if ($posmiar){
		      $MIURL = substr($MIURL,0, $posmiar - 1);	 
 		      $_POST['guest']['q_uri'] = $MIURL;
		 }
		 $MICOUNT= $_POST['guest']['q_count'] - 1;
		 $LANG= $_POST['guest']['q_lang'];

		 //llamamos archivo idiomas: array i18n de plugin
         if (is_file('lang/'.$LANG.'.php')){
			 include ('lang/'.$LANG.'.php');
		 } else {
			 include ('lang/en_US.php');
         }

         if ( $pot == trim(strtolower($_POST['guest']['pot']))) {
        	      $captcha = strtolower($_POST['guest']['pot']);
         } else {
 		 	$err = $i18n['MSG_CAPTCHA_FAILED'];
		 }

		 if ( $_POST['guest']['email'] != '' ) {
			if ($_POST['guest']['email'] != $i18n['em_text']){
				$from = $_POST['guest']['email'];
			} else {
				$_POST['guest']['email'] = '';
			}

		 }

         if ( $_POST['guest']['tema'] != '') {
			$tema = $_POST['guest']['tema'];
		 } else {
			$tema = '';
		 }

	$temp = $_POST['guest'];
	$temp['comentario'] = $_POST['comentario'];

         if ($err == '' && trim($_POST['guest']['nombre']) !='' && trim($_POST['comentario']) !='') {

			$server_name = getenv ("SERVER_NAME");       // Server Name
			$request_uri = getenv ("REQUEST_URI");       // Requested URI

			$headers = "From: ".$from."\r\n";
			$headers .= "Return-Path: ".$from."\r\n";
			$headers .= "Content-type: text/html; charset=UTF-8 \r\n";

			unset($temp['pot']);
			unset($temp['guest-submit']);
			unset($temp['submit']);
                        
			$body = '';
			$body .= $i18n['guest_FORM_SUB'].' '.$i18n['WHO'].' http://'.$server_name.$request_uri.' <br />';
			$body .= "-----------------------------------<br /><br />";


			if ( ! file_exists($log_file) ) {
               			$xml = new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><channel></channel>');
                                $count = 0;
				$sid = 0;
			} else
			{
				$xmldata = file_get_contents($log_file);
		       		$xml = new SimpleXMLExtended($xmldata);
			        //averiguamos que SubId lo toca mediante xpath
	   		        $domDocument = new DomDocument();
		                $domDocument->load($log_file);
		                // (2) Crear DOMXPath para poder filtrar mediante consulta
			        $xpath = new DOMXPath($domDocument);
			        //filtramos por valor del nodo entry/Id= $id
			        //para saber el valor del SubId y sumarle 1 si es necesario.
			        $verNode = $xpath->query("entry/SubId[../Id=$id]");
				$L_vn= $verNode->length;
				if ($L_vn == 0){
					$sid = 0;
				} else {
					$sid = ($verNode->item($L_vn -1)->nodeValue) + 1;
				}
			}

                        //grabamos los datos
				$thislog = $xml->addChild('entry');
                                $thislog->addAttribute('id', $id);
				$cdata = $thislog->addChild('Id');
				$cdata->addCData($id);
				$cdata = $thislog->addChild('SubId');
				$cdata->addCData($sid);
 				$cdata = $thislog->addChild('Nb');
				$cdata->addCData(htmlentities($temp['nombre'], ENT_QUOTES, 'UTF-8'));
				//$cdata->addCData(htmlentities($temp['nombre']));
				$thislog->addChild('date', date('r'));
				$cdata = $thislog->addChild('Sub');
				$cdata->addCData(htmlentities($tema, ENT_QUOTES, 'UTF-8'));
				//$cdata->addCData(htmlentities($tema));
        	                $cdata = $thislog->addChild('Em');
				$cdata->addCData(htmlentities($temp['email'], ENT_QUOTES, 'UTF-8'));
				//$cdata->addCData(htmlentities($temp['email']));
        	                $cdata = $thislog->addChild('Ct');
				$cdata->addCData(htmlentities($temp['city'], ENT_QUOTES, 'UTF-8'));
				//$cdata->addCData(htmlentities($temp['city']));
				$cdata = $thislog->addChild('Cm');
        	                $cdata->addCData(htmlentities($temp['comentario'], ENT_QUOTES, 'UTF-8'));
        	                //$cdata->addCData(htmlentities($temp['comentario']));
				$cdata = $thislog->addChild('captcha');
				$cdata->addCData($captcha);
				$cdata = $thislog->addChild('ip_address');
				$ip = getenv("REMOTE_ADDR");
				//$cdata->addCData(htmlentities($ip, ENT_QUOTES, 'UTF-8'));
				$cdata->addCData(htmlentities($ip));
				$cdata = $thislog->addChild('answ');
				$cdata->addCData($answ);
	
				foreach ( $temp as $key => $value ) {
					if (substr($key, 0, 2) != 'q_') {
						$body .= ucfirst($key) .": ". $value ."<br />";
					}
				}
				
				XMLsave($xml, $log_file);

			    //Send email
			    $result = mail($EMAIL,$i18n['guest_FORM_SUB'],$body,$headers);
                            $seg = 2;
                            $msgshw = '';
			    if ($result=='1') {
				   $msgshw = $i18n['MSG_guestSUC'].'<br /><br />';
			    } else {
			     /*	echo '<font color="red">*** '.strtoupper(utf8_encode($tr_cont['MSG_guestERR'])).'. ***</font>'; */
			    }
		    } else {  //finaliza if err=''
                            $miarr = '';
                            $miarr = serialize($temp);
                            $miarr = urlencode($miarr);
                            if (strpos($MIURL, '?')){
                                $miarr = '&amp;miarr='.$miarr;
                            } else {
                                $miarr = '?miarr='.$miarr;
                            }    
                            //Si hay algún error en captcha ó campos vacíos.
                             $seg=4;
			     if (trim($err) !=''){
			       	$msgshw = '<div id="msgerr">*** '.strtoupper($err).'. ***<br />'.strtoupper($i18n['Cap']).': '.$pot.'<br / >'.strtoupper($i18n['Code']).': '.$_POST['guest']['pot'].'</div><br />';
			     }
		        else {
			     	$msgshw = '<div id="msgerr">*** '.strtoupper($i18n['Co']).' ***</div><br />';
			    }
		    }
	} //finish guest-submit


  }   //FINISH GUEST


  echo '<html>';
  echo '<head>';
  echo '<meta http-equiv="Refresh" content="'.$seg.';url=http://'.$server_name.$MIURL.$miarr.'">';
  echo '<link rel="stylesheet" href="guest.css">';
  echo '</head>';
  echo '<body>';
  echo $msgshw;
  echo $i18n['redir'].$seg.$i18n['redir1'].$i18n['back'].'<br />';
  echo '<a href="http://'.$server_name.$MIURL.$miarr.'"> '.strtoupper($i18n['back']).'</a>';
  echo '</body>';
  echo '</html>';
?>
